#folder=
folder=./ProcessedOutputs/
NEMO_VERSION=$1

file=lbclnk.f90
to_replace="ptab%val_ptr(kfld)%pt"
replacement="ptab_ptr(kfld)%pt"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i


file=domngb.f90
to_replace="iloc(:) = MINLOC( zdist(:,:), mask = zmask(:,:) == 1.e0 )"
replacement="iloc(:) = MINLOC( zdist(:,:)%val, mask = zmask(:,:)%val == 1.e0 )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i


file=trc_oce.f90
to_replace="READ(numlight,\*) zchl%val, ( prgb(jb,jc), jb = 1, 3 )%val"
replacement="READ(numlight,\*) zchl%val, ( prgb(jb,jc)%val, jb = 1, 3 )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

file=diaptr.f90
to_replace="htr_ove(:,1) = SUM( v_msf(:,:,1)\*tn_jk(:,:,1) ,2 )"
replacement="htr_ove(:,1) = SUM( v_msf(:,:,1)%val\*tn_jk(:,:,1)%val ,2 )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

to_replace="str_ove(:,1) = SUM( v_msf(:,:,1)\*sn_jk(:,:,1) ,2 )"
replacement="str_ove(:,1) = SUM( v_msf(:,:,1)%val\*sn_jk(:,:,1)%val ,2 )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

to_replace="str_ove(:,jn) = SUM( v_msf(:,:,jn)\*sn_jk(:,:,jn) ,2 )"
replacement="str_ove(:,jn) = SUM( v_msf(:,:,jn)%val\*sn_jk(:,:,jn)%val ,2 )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

to_replace="htr_ove(:,jn) = SUM( v_msf(:,:,jn)\*tn_jk(:,:,jn) ,2 )"
replacement="htr_ove(:,jn) = SUM( v_msf(:,:,jn)%val\*tn_jk(:,:,jn)%val ,2 )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

file=geo2ocean.f90
to_replace="type(rpe_var), PARAMETER :: rad =  rpe_var( 52, rpi / 180.e0 )"
replacement="type(rpe_var), PARAMETER :: rad =  rpe_var( 52, rpi%val / 180.e0 )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

file=fldread.f90
to_replace="IF(lwp) WRITE(\*,\*) 'DEPTHU',real(  zh ),real(  sum(e3u_n(zij,zjj,:), mask=umask(zij,zjj,:)==1) ),real(  sum(umask(zij,zjj,:)) ),real(  hu_n(zij,zjj) ), map%ptr(ib), ib, zij, zjj, narea-1  ,real(  dta_read(map%ptr(ib),1,:) )"
replacement="IF(lwp) WRITE(\*,\*) 'DEPTHU',real(  zh ),real(  sum(e3u_n(zij,zjj,:)%val, mask=umask(zij,zjj,:)%val==1) ),real(  sum(umask(zij,zjj,:)) ),real(  hu_n(zij,zjj) ), map%ptr(ib), ib, zij, zjj, narea-1  ,real(  dta_read(map%ptr(ib),1,:) )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

to_replace="ELSEIF( zl > MAXVAL(dta_read_z(map%ptr(ib),1,:),1) ) THEN"
replacement="ELSEIF( zl > MAXVAL(dta_read_z(map%ptr(ib),1,:)%val,1) ) THEN"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

to_replace="dta(ib,1,ik) =  dta_read(map%ptr(ib),1,MAXLOC(dta_read_z(map%ptr(ib),1,:),1))"
replacement="dta(ib,1,ik) =  dta_read(map%ptr(ib),1,MAXLOC(dta_read_z(map%ptr(ib),1,:)%val,1))"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

to_replace="ELSEIF( zl > MAXVAL(dta_read_z(ji,jj,:),1) ) THEN"
replacement="ELSEIF( zl > MAXVAL(dta_read_z(ji,jj,:)%val,1) ) THEN"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

to_replace="dta(ib,1,ik) =  dta_read(ji,jj,MAXLOC(dta_read_z(ji,jj,:),1))"
acement="dta(ib,1,ik) =  dta_read(ji,jj,MAXLOC(dta_read_z(ji,jj,:)%val,1))"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

to_replace="zlsm2d = SUM( zlsm3d, 3 , ll_msknan3d ) / MAX( 1 , COUNT( ll_msknan3d , 3 )"
replacement="zlsm2d = SUM( zlsm3d%val, 3 , ll_msknan3d ) / MAX( 1 , COUNT( ll_msknan3d , 3 )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

to_replace="pdta(jb,1,jk) =  pdta_read(jb,1,MAXLOC(pdta_read_z(jb,1,:),1))"
replacement="pdta(jb,1,jk) =  pdta_read(jb,1,MAXLOC(pdta_read_z(jb,1,:)%val,1))"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

file=obs_averg_h2d.f90
to_replace="pobsk(jk) = SUM (real(  pweig(:,:,jk) \* pmod(:,:,jk) ), Mask=real( pweig(:,:,jk) > 0.0_wp  ))"
replacement="pobsk(jk) = SUM (  pweig(:,:,jk)%val \* pmod(:,:,jk)%val, Mask=pweig(:,:,jk)%val > 0.0_wp  )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i


#Special case patch (Too hard for a sed command)

file=sbcwave.f90
to_replace="ERFC(zsqrt_depth)"
replacement="ERFC(zsqrt_depth%val)"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i


file=domain.f90
to_replace="iloc  = MINLOC( e1t(:,:), mask = tmask_i(:,:) == 1._wp )"
replacement="iloc  = MINLOC( e1t(:,:)%val, mask = tmask_i(:,:)%val == 1._wp )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

to_replace="iloc  = MINLOC( e2t(:,:), mask = tmask_i(:,:) == 1._wp )"
replacement="iloc  = MINLOC( e2t(:,:)%val, mask = tmask_i(:,:)%val == 1._wp )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i


file=dynvor.f90
to_replace="WRITE(numout,\*) real( '         e3f = averaging /4 (=0) or /sum(tmask) (=1)    nn_een_e3f = ' ), nn_een_e3f"
replacement="WRITE(numout,\*) '         e3f = averaging /4 (=0) or /sum(tmask) (=1)    nn_een_e3f = ', nn_een_e3f"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

file=sbcblk.f90
to_replace="type(rpe_var), PARAMETER ::   reps0 =  rpe_var( 52, R_dry/R_vap )"
replacement="type(rpe_var), PARAMETER ::   reps0 =  rpe_var( 52, R_dry%val/R_vap%val )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

to_replace="type(rpe_var), PARAMETER ::   rctv0 =  rpe_var( 52, R_vap/R_dry )"
replacement="type(rpe_var), PARAMETER ::   rctv0 =  rpe_var( 52, R_vap%val/R_dry%val )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

file=sbcmod.f90
to_replace="zthscl = atanh(rn_wd_sbcfra)"
replacement="zthscl = atanh(rn_wd_sbcfra%val)"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

file=sshwzv.f90
to_replace="type(rpe_var) , PARAMETER ::   Cu_cut =  rpe_var( 52, 2._wp\*Cu_max - Cu_min )"
replacement="type(rpe_var) , PARAMETER ::   Cu_cut =  rpe_var( 52, 2._wp\*Cu_max%val - Cu_min%val )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i

to_replace="type(rpe_var) , PARAMETER ::   Fcu    =  rpe_var( 52, 4._wp\*Cu_max\*(Cu_max-Cu_min) )"
replacement="type(rpe_var) , PARAMETER ::   Fcu    =  rpe_var( 52, 4._wp\*Cu_max%val\*(Cu_max%val-Cu_min%val) )"
sed "s#${to_replace}#${replacement}#g" ${folder}/${file} -i


#Special case patch (Too hard for a sed command)
for patch_file in Files/${NEMO_VERSION}/*.patch
do
  echo ${file}' patching file '${file}
  patch_name=${patch_file##*/}
  file=${patch_name%.*}.f90
  patch ${folder}/${file} ${patch_file}
  echo  'file patched'
done 
